package transform.test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.jboss.soa.esb.util.FileUtil;

public class FileConverterClient {
    QueueConnection conn;
    QueueSession session;
    Queue que;
    
    
    public void setupConnection() throws JMSException, NamingException
    {
	    Properties properties1 = new Properties();
		properties1.put(Context.INITIAL_CONTEXT_FACTORY,
				"org.jnp.interfaces.NamingContextFactory");
		properties1.put(Context.URL_PKG_PREFIXES,
				"org.jboss.naming:org.jnp.interfaces");
		properties1.put(Context.PROVIDER_URL, "jnp://localhost:1099");
		InitialContext iniCtx = new InitialContext(properties1);
    
    	Object tmp = iniCtx.lookup("ConnectionFactory");
    	QueueConnectionFactory qcf = (QueueConnectionFactory) tmp;
    	conn = qcf.createQueueConnection();
    	que = (Queue) iniCtx.lookup("queue/transform_Request_gw");
    	session = conn.createQueueSession(false, QueueSession.AUTO_ACKNOWLEDGE);
    	conn.start();
    	System.out.println("Connection Started");
    }
    
    public void stop() throws JMSException 
    { 
        conn.stop();
        session.close();
        conn.close();
    }
    
    public void sendAMessage(String fileName) throws JMSException, FileNotFoundException, IOException {
    	
        QueueSender send = session.createSender(que);
        ObjectMessage tm;
        File file = new File(fileName);

        if(!file.exists()) {
        	throw new IllegalArgumentException("Input message file [" + file.getAbsolutePath() + "] not found.");
        }
        
        String message = FileUtil.readTextFile(file);
        System.out.println("message-->"+message);
        tm = session.createObjectMessage(message);
    
        send.send(tm);        
        send.close();
        
        System.out.println("*** Switch back to the ESB Java console now to see '" + fileName + "' before and after the transformation...");
    }
       
    
    public static void main(String args[]) throws Exception
    {        	    	
    	FileConverterClient sm = new FileConverterClient();
    	sm.setupConnection();
    	sm.sendAMessage("input-message.csv"); 
    	sm.stop();
    }
    
}
